import { DbConfig$Type } from '../types';
export default class SyncDb {
    private worker;
    constructor(type?: DbConfig$Type, dbPath?: string, isTrie?: boolean, withCompact?: boolean);
    initialise(): Promise<void>;
    checkpoint(): void;
    commit(): void;
    revert(): void;
    del(key: Uint8Array): void;
    get(key: Uint8Array): Uint8Array | null;
    put(key: Uint8Array, value: Uint8Array): void;
    getRoot(): Uint8Array;
    hasRoot(root: Uint8Array): boolean;
    setRoot(root: Uint8Array): void;
    terminate(): Promise<void>;
    private _waitOnStart;
    private _waitOnRead;
    private _executeWrite;
    private _executeReadSize;
    private _executeRead;
    private _readSize;
    private _readBuffer;
}
