"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _param = _interopRequireDefault(require("@polkadot/params/param"));

var _section = _interopRequireDefault(require("@polkadot/params/section"));

// Copyright 2017-2018 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
const name = 'block';

var _default = (0, _section.default)(name)(createMethod => ({
  description: 'Block storage (internal)',
  public: {
    bestHash: createMethod('bestHash')({
      description: 'Best hash',
      key: 'bst:hsh',
      params: [],
      type: 'Hash'
    }),
    bestNumber: createMethod('bestNumber')({
      description: 'Best block',
      key: 'bst:num',
      params: [],
      type: 'BlockNumber'
    }),
    blockByHash: createMethod('blockByHash')({
      description: 'Retrieve block by hash',
      params: [(0, _param.default)('hash', 'Hash')],
      key: 'blk:hsh:',
      type: 'Bytes'
    }),
    headerByHash: createMethod('headerByHash')({
      description: 'Retrieve header by hash',
      params: [(0, _param.default)('hash', 'Hash')],
      key: 'hdr:hsh:',
      type: 'Bytes'
    })
  }
}));

exports.default = _default;