"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = decodeArrayU8a;

var _toU8a = _interopRequireDefault(require("@polkadot/util/bn/toU8a"));

var _concat = _interopRequireDefault(require("@polkadot/util/u8a/concat"));

var _toBn = _interopRequireDefault(require("@polkadot/util/u8a/toBn"));

var _key = _interopRequireDefault(require("../key"));

// Copyright 2017-2018 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
function decodeArrayU8a(db, key) {
  const createKey = (0, _key.default)(key);
  return {
    del: (...keyParams) => db.del(createKey(keyParams)),
    get: (...keyParams) => {
      const u8a = db.get(createKey(keyParams));

      if (u8a === null) {
        return [];
      }

      const length = (0, _toBn.default)(u8a.subarray(0, 4), true).toNumber();
      const result = [];
      let offset = 4;

      for (let index = 0; index < length; index++, offset += 32) {
        result.push(u8a.subarray(offset, offset + 32));
      }

      return result;
    },
    set: (value, ...keyParams) => db.put(createKey(keyParams), (0, _concat.default)((0, _toU8a.default)(value.length, 32, true), _concat.default.apply(null, value))),
    onUpdate: updater => {
      throw new Error(`No subscriber available for db/arrayU8a`);
    }
  };
}