"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = decodeBool;

var _base = _interopRequireDefault(require("./base"));

var _key = _interopRequireDefault(require("../key"));

// Copyright 2017-2018 @polkadot/client-db authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
function decodeBool(db, key) {
  const createKey = (0, _key.default)(key);
  const base = (0, _base.default)(db);
  return {
    del: (...keyParams) => base.del(createKey(keyParams)),
    get: (...keyParams) => {
      const value = base.get(createKey(keyParams));
      return value[0] === 1;
    },
    set: (value, ...keyParams) => base.set(createKey(keyParams), value, new Uint8Array([value ? 1 : 0])),
    onUpdate: updater => base.onUpdate(updater)
  };
}